#!/bin/bash

# This script ease the process of performing the "Replace a pre-login executable file" procedure
# It will replace the sethc.exe with cmd.exe and make a backup of the old sethc.exe file.
# This script has also got support for reverting back to normal after the resetting has been done. 

path=$1
mountfolder="/mnt/os"
xp="$mountfolder/WINDOWS/system32"
vistaN7="$mountfolder/Windows/System32"

if [ -z $path ]
	then
	if [ -d $xp ]
		then
		path=$xp
	elif [ -d $vistaN7 ]
		then
		path=$vistaN7
	else
		echo "Please enter the path to the windows system32 folder e.g. /mnt/os/Windows/System32/"
		read tmp
		path=$tmp
	fi
fi

finished="false"
while [ $finished == "false" ]
do
	echo ---------------------------------------------------------- ---------------------------------
	echo This script can replace the sticky keys startup program or revert to backup if already done.
	echo ---------------------------------------------------------- ---------------------------------
	echo 
	echo "Do you want to 'replace' the sethc.exe or 'revert' to backup?"
	read answer
	case $answer in
		replace)
			if [ -e $path/sethc.exe.bak ]
				then
				echo "It seems that a backup file exists. Maybe you have already replaced the file."
				echo "Are you sure you want to replace? Type 'yes' to confirm."
				read answer3
				if [ $answer3 == "yes" ]
					then
					cp $path/sethc.exe $path/sethc.exe.bak
					cp $path/cmd.exe $path/sethc.exe
					echo ------------------------------ ------------------------------ -----------------
					echo Replace done. You can now reboot the machine and by pressing shift 5 times
					echo enter a Windows command console, cmd.exe, to perform further password handling.
					echo ------------------------------ ------------------------------ -----------------
					exit
				fi						
			else
				echo "Are you sure you want to replace the startupfile? Type 'yes' to confirm."
				read answer2
				if [ $answer2 == "yes" ]
					then
					cp $path/sethc.exe $path/sethc.exe.bak
					cp $path/cmd.exe $path/sethc.exe
					echo ------------------------------ ------------------------------ -----------------
                    			echo Replace done. You can now reboot the machine and by pressing shift 5 times
                    			echo enter a Windows command console, cmd.exe, to perform further password handling.
                    			echo ------------------------------ ------------------------------ -----------------
					exit
				fi
			fi
			;;
		revert)
			echo Will try to revert from the backupfile hopefully located at:
			echo $path/sethc.exe.bak
			mv $path/sethc.exe.bak $path/sethc.exe
			echo -------------------------------------------- ----------------------------------
            		echo Revert done. You can now reboot the machine and sticky keys should be restored
            		echo to normal. The changes done from Windows command console will not be reverted. 
            		echo -------------------------------------------- ----------------------------------
			exit
			;;
		*)
			echo Will exit, have a nice day!
			exit
			;;
	esac
done
