#!/bin/bash

custom_kernel="../custom_kernel/2.6.26.2"
images="../images"
other_packages="../other_packages"
other_scripts="../other_scripts"
our_scripts="../our_scripts"
local_hooks="../local_hooks"

aptitude install --assume-yes live-helper

mkdir livecd
cd livecd

lh_config --iso-volume "YALP" --iso-publisher "Jrgen Blakstad and Rune Wals Nergrd" --hostname YALP --username user --bootappend-live "keyb=no" --mirror-bootstrap "http://ftp.no.debian.org/debian/" --mirror-chroot "http://ftp.no.debian.org/debian/" --mirror-binary "http://ftp.no.debian.org/debian/" --packages "chntpw locate john ntfs-3g openssh-client libdigest-md4-perl libcrypt-passwdmd5-perl libfuse2 fuse-utils dmsetup libsm6 lvm2 less" --syslinux-menu enabled --syslinux-timeout 10

mkdir config/chroot_local-includes/home
mkdir config/chroot_local-includes/home/user
cp $our_scripts/* $other_scripts/* config/chroot_local-includes/home/user/
cp $other_packages/* $custom_kernel/* config/chroot_local-packages/
cp $images/yalp.rle config/binary_syslinux/yalp.rle
sed 's/LH_SYSLINUX_SPLASH=""/LH_SYSLINUX_SPLASH="config\/binary_syslinux\/yalp.rle"/' config/binary >test
sed 's/LH_SYSLINUX_MENU_LIVE_ENTRY="Start Debian Live"/LH_SYSLINUX_MENU_LIVE_ENTRY="Start YALP"/' test >test2
mv test2 config/binary
rm test
sed 's/LH_LINUX_PACKAGES="/LH_LINUX_PACKAGES="none" #/' config/chroot >test
sed 's/LH_LINUX_FLAVOURS="/LH_LINUX_FLAVOURS="dlb" #/' test >test2
mv test2 config/chroot
rm test
cp $local_hooks/* config/chroot_local-hooks
lh_build
