#!/usr/bin/perl
use Crypt::PasswdMD5;
use File::Copy;

# This script edits the /etc/shadow file. It replaces an old md5 hash with a new one created for a desired password


my $old = "";
foreach (@ARGV) { $old = "$_" }
if($old eq ""){
	print "Please enter the folder where the shadow file is located ie. '/etc/shadow' : ";
	chomp($old = <STDIN>);
}
#my $old = '/etc/shadow';
my $new = 'shadow.tmp';
my $bak = "$old.bak";
my $typo = 0;
my $edit = 0;

open(OLD,'<',$old)			or die "can't open $old: $!";
open(NEW,'>',$new)			or die "can't open $new: $!";

my($username,$temp,$temp2,$temp3,$alg,$salt2,$hash2,$rest,$line);
while($line = <OLD>){
	if($line =~ m/\$1\$/){
#		print "$line";
		$username = substr $line, 0, index($line, ':');
		print "Is '$username' the correct user? Enter 'yes' or 'no': ";
		chomp(my $correctuser = <STDIN>);
		if($correctuser eq "yes"){
			print "Insert desired password: ";
			chomp(my $password = <STDIN>);
			print "Insert desired salt: ";
			chomp(my $salt = <STDIN>);
			$crypted = unix_md5_crypt($password, $salt);
			my $hash = substr $crypted, 4+length($salt);
			$edit = 1;
			$temp = substr $line, length($username);
			$alg = substr $temp, 2, 1;
			$temp2 = substr $temp, 4;
			$salt2 = substr $temp2, 0, index($temp2, '$');
			$temp3 = substr $temp2, length($salt2);
			$hash2 = substr $temp3, 1, index($temp3,':')-1;
			$rest = substr $temp3, length($hash2);
			$line =~ s/$salt2/$salt/;
			$line =~ s/$hash2/$hash/;
#			print "$line\n";
			print NEW $line;
		}elsif($correctuser eq "no"){	
			print NEW $line;
		}else{
			print "You typed wrong, please type 'yes' or 'no'!\n";
			$typo = 1;
		}
	}else{
		print NEW $line;
	}
}
if($typo == 0 && $edit == 1){

	close(OLD)					or die "can't close $old: $!";
	close(NEW)					or die "can't close $new: $!";

	move($old, $bak)          or die "can't rename $old to $bak: $!";
	move($new, $old)          or die "can't rename $new to $old: $!";
}else{
	close(OLD)					or die "can't close $old: $!";
	close(NEW)					or die "can't close $new: $!";

	unlink($new)				or die "can't delete $old: $!";
}

